%
% Generated from "Aislib" Patterns class, see: http://www.erikburrows.com/index.php?node=AISlib
% Copyright Erik G. Burrows, 2010. Licensed under GPL version 2.
%
-define(AisPatterns, [
  [
    {pattern, "^001011.*"},
    {name,"msg11_station_info"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {utcYear, int, [{min_length, 14},{max_length, 14}]},
      {utcMonth, int, [{min_length, 4},{max_length, 4}]},
      {utcDay, int, [{min_length, 5},{max_length, 5}]},
      {utcHour, int, [{min_length, 5},{max_length, 5}]},
      {utcMinute, int, [{min_length, 6},{max_length, 6}]},
      {utcSecond, int, [{min_length, 6},{max_length, 6}]},
      {positionAccuracy, int, [{min_length, 1},{max_length, 1}]},
      {longitude, float, [{min_length, 28},{max_length, 28},{divisor, 600000}]},
      {latitude, float, [{min_length, 27},{max_length, 27},{divisor, 600000}]},
      {fixDeviceType, int, [{min_length, 4},{max_length, 4}]},
      {spare, int, [{min_length, 10},{max_length, 10}]},
      {raimFlag, int, [{min_length, 1},{max_length, 1}]},
      {communicationStatus, int, [{min_length, 19},{max_length, 19}]}
    ]}
  ],
  [
    {pattern, "^010000.{138}"},
    {name,"msg16_assignment_mode_command_2_dest"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {offset1, int, [{min_length, 12},{max_length, 12}]},
      {increment1, int, [{min_length, 10},{max_length, 10}]},
      {destinationMmsi2, int, [{min_length, 30},{max_length, 30}]},
      {offset2, int, [{min_length, 12},{max_length, 12}]},
      {increment2, int, [{min_length, 10},{max_length, 10}]}
    ]}
  ],
  [
    {pattern, "^010001.*"},
    {name,"msg17_dgnss_broadcast"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {longitude, float, [{min_length, 18},{max_length, 18},{divisor, 600}]},
      {latitude, float, [{min_length, 17},{max_length, 17},{divisor, 600}]},
      {spare2, int, [{min_length, 5},{max_length, 5}]},
      {data, data, [{min_length, 0},{max_length, 736}]}
    ]}
  ],
  [
    {pattern, "^000001.*"},
    {name,"msg1_dynamic_info"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {navigationalStatus, int, [{min_length, 4},{max_length, 4}]},
      {rateOfTurn, int, [{min_length, 8},{max_length, 8}]},
      {speedOverGround, int, [{min_length, 10},{max_length, 10}]},
      {positionAccuracy, int, [{min_length, 1},{max_length, 1}]},
      {longitude, float, [{min_length, 28},{max_length, 28},{divisor, 600000}]},
      {latitude, float, [{min_length, 27},{max_length, 27},{divisor, 600000}]},
      {courseOverGround, float, [{min_length, 12},{max_length, 12},{divisor, 10}]},
      {trueHeading, int, [{min_length, 9},{max_length, 9}]},
      {utc, int, [{min_length, 6},{max_length, 6}]},
      {maneuver, int, [{min_length, 2},{max_length, 2}]},
      {spare, int, [{min_length, 3},{max_length, 3}]},
      {raimFlag, int, [{min_length, 1},{max_length, 1}]},
      {communicationStatus, int, [{min_length, 19},{max_length, 19}]}
    ]}
  ],
  [
    {pattern, "^001010.*"},
    {name,"msg9_utc_date_inquiry"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare2, int, [{min_length, 2},{max_length, 2}]}
    ]}
  ],
  [
    {pattern, "^010100.{64}.*"},
    {name,"msg20_data_link_management_1_slot"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {offset1, int, [{min_length, 12},{max_length, 12}]},
      {slots1, int, [{min_length, 4},{max_length, 4}]},
      {timeout1, int, [{min_length, 3},{max_length, 3}]},
      {increment1, int, [{min_length, 11},{max_length, 11}]}
    ]}
  ],
  [
    {pattern, "^010000.{90}"},
    {name,"msg16_assignment_mode_command_1_dest"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {offset1, int, [{min_length, 12},{max_length, 12}]},
      {increment1, int, [{min_length, 10},{max_length, 10}]},
      {spare2, int, [{min_length, 4},{max_length, 4}]}
    ]}
  ],
  [
    {pattern, "^010100.{94}.*"},
    {name,"msg20_data_link_management_2_slots"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {offset1, int, [{min_length, 12},{max_length, 12}]},
      {slots1, int, [{min_length, 4},{max_length, 4}]},
      {timeout1, int, [{min_length, 3},{max_length, 3}]},
      {increment1, int, [{min_length, 11},{max_length, 11}]},
      {offset2, int, [{min_length, 12},{max_length, 12}]},
      {slots2, int, [{min_length, 4},{max_length, 4}]},
      {timeout2, int, [{min_length, 3},{max_length, 3}]},
      {increment2, int, [{min_length, 11},{max_length, 11}]}
    ]}
  ],
  [
    {pattern, "^010110.*"},
    {name,"msg22_channel_management"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {channelA, int, [{min_length, 12},{max_length, 12}]},
      {channelB, int, [{min_length, 12},{max_length, 12}]},
      {transmitReceiveMode, int, [{min_length, 4},{max_length, 4}]},
      {power, int, [{min_length, 1},{max_length, 1}]},
      {longitude1, float, [{min_length, 18},{max_length, 18},{divisor, 600}]},
      {latitude1, float, [{min_length, 17},{max_length, 17},{divisor, 600}]},
      {longitude2, float, [{min_length, 18},{max_length, 18},{divisor, 600}]},
      {latitude2, float, [{min_length, 17},{max_length, 17},{divisor, 600}]},
      {addressOrBroadcast, int, [{min_length, 1},{max_length, 1}]},
      {channelABW, int, [{min_length, 1},{max_length, 1}]},
      {channelBBW, int, [{min_length, 1},{max_length, 1}]},
      {transmissionZoneSite, int, [{min_length, 3},{max_length, 3}]},
      {spare2, int, [{min_length, 23},{max_length, 23}]}
    ]}
  ],
  [
    {pattern, "^000110.*"},
    {name,"msg6_addressed_binary_message"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {sequence, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi, int, [{min_length, 30},{max_length, 30}]},
      {retransmit, int, [{min_length, 1},{max_length, 1}]},
      {spare, int, [{min_length, 1},{max_length, 1}]},
      {applicationId, int, [{min_length, 16},{max_length, 16}]},
      {data, data, [{min_length, 0},{max_length, 920}]}
    ]}
  ],
  [
    {pattern, "^001101.{98}"},
    {name,"msg13_safety_ack_2_destinations"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber1, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi2, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber2, int, [{min_length, 2},{max_length, 2}]}
    ]}
  ],
  [
    {pattern, "^001101.{66}"},
    {name,"msg13_safety_ack_1_destination"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber1, int, [{min_length, 2},{max_length, 2}]}
    ]}
  ],
  [
    {pattern, "^010100.{124}.*"},
    {name,"msg20_data_link_management_3_slots"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {offset1, int, [{min_length, 12},{max_length, 12}]},
      {slots1, int, [{min_length, 4},{max_length, 4}]},
      {timeout1, int, [{min_length, 3},{max_length, 3}]},
      {increment1, int, [{min_length, 11},{max_length, 11}]},
      {offset2, int, [{min_length, 12},{max_length, 12}]},
      {slots2, int, [{min_length, 4},{max_length, 4}]},
      {timeout2, int, [{min_length, 3},{max_length, 3}]},
      {increment2, int, [{min_length, 11},{max_length, 11}]},
      {offset3, int, [{min_length, 12},{max_length, 12}]},
      {slots3, int, [{min_length, 4},{max_length, 4}]},
      {timeout3, int, [{min_length, 3},{max_length, 3}]},
      {increment3, int, [{min_length, 11},{max_length, 11}]}
    ]}
  ],
  [
    {pattern, "^001100.*"},
    {name,"msg12_addressed_safety_message"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {sequence, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi, int, [{min_length, 30},{max_length, 30}]},
      {retransmitFlag, int, [{min_length, 1},{max_length, 1}]},
      {spare, int, [{min_length, 1},{max_length, 1}]},
      {text, string, [{min_length, 0},{max_length, 936}]}
    ]}
  ],
  [
    {pattern, "^010011.*"},
    {name,"msg19_class_b_extended_info"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {localApplicationData, int, [{min_length, 8},{max_length, 8}]},
      {speedOverGround, float, [{min_length, 10},{max_length, 10},{divisor, 10}]},
      {positionAccuracy, int, [{min_length, 1},{max_length, 1}]},
      {longitude, float, [{min_length, 28},{max_length, 28},{divisor, 600000}]},
      {latitude, float, [{min_length, 27},{max_length, 27},{divisor, 600000}]},
      {courseOverGround, float, [{min_length, 12},{max_length, 12},{divisor, 10}]},
      {trueHeading, int, [{min_length, 9},{max_length, 9}]},
      {timestamp, int, [{min_length, 6},{max_length, 6}]},
      {regionalApplicationData, int, [{min_length, 4},{max_length, 4}]},
      {name, string, [{min_length, 120},{max_length, 120}]},
      {shipCargoType, int, [{min_length, 8},{max_length, 8}]},
      {lengthFore, int, [{min_length, 9},{max_length, 9}]},
      {lengthAft, int, [{min_length, 9},{max_length, 9}]},
      {widthPort, int, [{min_length, 6},{max_length, 6}]},
      {widthStarboard, int, [{min_length, 6},{max_length, 6}]},
      {fixDeviceType, int, [{min_length, 4},{max_length, 4}]},
      {raimFlag, int, [{min_length, 1},{max_length, 1}]},
      {dte, int, [{min_length, 1},{max_length, 1}]},
      {assignedMode, int, [{min_length, 1},{max_length, 1}]},
      {spare, int, [{min_length, 4},{max_length, 4}]}
    ]}
  ],
  [
    {pattern, "^000011.*"},
    {name,"msg3_dynamic_info"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {navigationalStatus, int, [{min_length, 4},{max_length, 4}]},
      {rateOfTurn, int, [{min_length, 8},{max_length, 8}]},
      {speedOverGround, int, [{min_length, 10},{max_length, 10}]},
      {positionAccuracy, int, [{min_length, 1},{max_length, 1}]},
      {longitude, float, [{min_length, 28},{max_length, 28},{divisor, 600000}]},
      {latitude, float, [{min_length, 27},{max_length, 27},{divisor, 600000}]},
      {courseOverGround, float, [{min_length, 12},{max_length, 12},{divisor, 10}]},
      {trueHeading, int, [{min_length, 9},{max_length, 9}]},
      {utc, int, [{min_length, 6},{max_length, 6}]},
      {maneuver, int, [{min_length, 2},{max_length, 2}]},
      {spare, int, [{min_length, 3},{max_length, 3}]},
      {raimFlag, int, [{min_length, 1},{max_length, 1}]},
      {communicationStatus, int, [{min_length, 19},{max_length, 19}]}
    ]}
  ],
  [
    {pattern, "^011000.{2}.{30}01.*"},
    {name,"msg24_class_b_static_info_b"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {partNumber, int, [{min_length, 2},{max_length, 2}]},
      {shipCargoType, int, [{min_length, 8},{max_length, 8}]},
      {vendorId, string, [{min_length, 42},{max_length, 42}]},
      {callSign, string, [{min_length, 42},{max_length, 42}]},
      {lengthFore, int, [{min_length, 9},{max_length, 9}]},
      {lengthAft, int, [{min_length, 9},{max_length, 9}]},
      {widthPort, int, [{min_length, 6},{max_length, 6}]},
      {widthStarboard, int, [{min_length, 6},{max_length, 6}]},
      {spare, int, [{min_length, 6},{max_length, 6}]}
    ]}
  ],
  [
    {pattern, "^010100.{154}.*"},
    {name,"msg20_data_link_management_4_slots"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {offset1, int, [{min_length, 12},{max_length, 12}]},
      {slots1, int, [{min_length, 4},{max_length, 4}]},
      {timeout1, int, [{min_length, 3},{max_length, 3}]},
      {increment1, int, [{min_length, 11},{max_length, 11}]},
      {offset2, int, [{min_length, 12},{max_length, 12}]},
      {slots2, int, [{min_length, 4},{max_length, 4}]},
      {timeout2, int, [{min_length, 3},{max_length, 3}]},
      {increment2, int, [{min_length, 11},{max_length, 11}]},
      {offset3, int, [{min_length, 12},{max_length, 12}]},
      {slots3, int, [{min_length, 4},{max_length, 4}]},
      {timeout3, int, [{min_length, 3},{max_length, 3}]},
      {increment3, int, [{min_length, 11},{max_length, 11}]},
      {offset4, int, [{min_length, 12},{max_length, 12}]},
      {slots4, int, [{min_length, 4},{max_length, 4}]},
      {timeout4, int, [{min_length, 3},{max_length, 3}]},
      {increment4, int, [{min_length, 11},{max_length, 11}]}
    ]}
  ],
  [
    {pattern, "^001001.*"},
    {name,"msg9_sar_aircraft"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {altitude, int, [{min_length, 12},{max_length, 12}]},
      {speedOverGround, int, [{min_length, 10},{max_length, 10}]},
      {positionAccuracy, int, [{min_length, 1},{max_length, 1}]},
      {longitude, float, [{min_length, 28},{max_length, 28},{divisor, 600000}]},
      {latitude, float, [{min_length, 27},{max_length, 27},{divisor, 600000}]},
      {courseOverGround, float, [{min_length, 12},{max_length, 12},{divisor, 10}]},
      {utc, int, [{min_length, 6},{max_length, 6}]},
      {regionalApplication, int, [{min_length, 8},{max_length, 8}]},
      {dte, int, [{min_length, 1},{max_length, 1}]},
      {spare, int, [{min_length, 3},{max_length, 3}]},
      {assignedModeFlag, int, [{min_length, 1},{max_length, 1}]},
      {raimFlag, int, [{min_length, 1},{max_length, 1}]},
      {communicationStateSelectorFlag, int, [{min_length, 1},{max_length, 1}]},
      {communicationStatus, int, [{min_length, 19},{max_length, 19}]}
    ]}
  ],
  [
    {pattern, "^010010.*"},
    {name,"msg18_class_b_position"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {localApplicationData, int, [{min_length, 8},{max_length, 8}]},
      {speedOverGround, float, [{min_length, 10},{max_length, 10},{divisor, 10}]},
      {positionAccuracy, int, [{min_length, 1},{max_length, 1}]},
      {longitude, float, [{min_length, 28},{max_length, 28},{divisor, 600000}]},
      {latitude, float, [{min_length, 27},{max_length, 27},{divisor, 600000}]},
      {courseOverGround, float, [{min_length, 12},{max_length, 12},{divisor, 10}]},
      {trueHeading, int, [{min_length, 9},{max_length, 9}]},
      {timestamp, int, [{min_length, 6},{max_length, 6}]},
      {regionalApplicationData, int, [{min_length, 2},{max_length, 2}]},
      {csFlag, int, [{min_length, 1},{max_length, 1}]},
      {displayFlag, int, [{min_length, 1},{max_length, 1}]},
      {dscFlag, int, [{min_length, 1},{max_length, 1}]},
      {bandFlag, int, [{min_length, 1},{max_length, 1}]},
      {msg22Flag, int, [{min_length, 1},{max_length, 1}]},
      {assignedMode, int, [{min_length, 1},{max_length, 1}]},
      {raimFlag, int, [{min_length, 1},{max_length, 1}]},
      {communicationStatusSelectFlag, int, [{min_length, 1},{max_length, 1}]},
      {communicationStatus, int, [{min_length, 19},{max_length, 19}]}
    ]}
  ],
  [
    {pattern, "^000010.*"},
    {name,"msg2_dynamic_info"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {navigationalStatus, int, [{min_length, 4},{max_length, 4}]},
      {rateOfTurn, int, [{min_length, 8},{max_length, 8}]},
      {speedOverGround, int, [{min_length, 10},{max_length, 10}]},
      {positionAccuracy, int, [{min_length, 1},{max_length, 1}]},
      {longitude, float, [{min_length, 28},{max_length, 28},{divisor, 600000}]},
      {latitude, float, [{min_length, 27},{max_length, 27},{divisor, 600000}]},
      {courseOverGround, float, [{min_length, 12},{max_length, 12},{divisor, 10}]},
      {trueHeading, int, [{min_length, 9},{max_length, 9}]},
      {utc, int, [{min_length, 6},{max_length, 6}]},
      {maneuver, int, [{min_length, 2},{max_length, 2}]},
      {spare, int, [{min_length, 3},{max_length, 3}]},
      {raimFlag, int, [{min_length, 1},{max_length, 1}]},
      {communicationStatus, int, [{min_length, 19},{max_length, 19}]}
    ]}
  ],
  [
    {pattern, "^001111.{160}"},
    {name,"msg15_interrogation_4_3"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {messageId1_1, int, [{min_length, 6},{max_length, 6}]},
      {slotOffset1_1, int, [{min_length, 12},{max_length, 12}]},
      {spare2, int, [{min_length, 2},{max_length, 2}]},
      {messageId1_2, int, [{min_length, 6},{max_length, 6}]},
      {slotOffset1_2, int, [{min_length, 12},{max_length, 12}]},
      {spare3, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi2, int, [{min_length, 30},{max_length, 30}]},
      {messageId2_1, int, [{min_length, 6},{max_length, 6}]},
      {slotOffset2_1, int, [{min_length, 12},{max_length, 12}]},
      {spare4, int, [{min_length, 2},{max_length, 2}]}
    ]}
  ],
  [
    {pattern, "^011000.{2}.{30}00.*"},
    {name,"msg24_class_b_static_info_a"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {partNumber, int, [{min_length, 2},{max_length, 2}]},
      {name, string, [{min_length, 120},{max_length, 120}]}
    ]}
  ],
  [
    {pattern, "^001111.{108}"},
    {name,"msg15_interrogation_2"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {messageId1_1, int, [{min_length, 6},{max_length, 6}]},
      {slotOffset1_1, int, [{min_length, 12},{max_length, 12}]},
      {spare2, int, [{min_length, 2},{max_length, 2}]},
      {messageId1_2, int, [{min_length, 6},{max_length, 6}]},
      {slotOffset1_2, int, [{min_length, 12},{max_length, 12}]}
    ]}
  ],
  [
    {pattern, "^001000.*"},
    {name,"msg8_binary_broadcast"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {applicationID, int, [{min_length, 16},{max_length, 16}]},
      {data, data, [{min_length, 0},{max_length, 952}]}
    ]}
  ],
  [
    {pattern, "^001111.*"},
    {name,"msg15_interrogation_1"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {messageId1_1, int, [{min_length, 6},{max_length, 6}]},
      {slotOffset1_1, int, [{min_length, 12},{max_length, 12}]}
    ]}
  ],
  [
    {pattern, "^000111.{130}"},
    {name,"msg7_binary_ack_3_destinations"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber1, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi2, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber2, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi3, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber3, int, [{min_length, 2},{max_length, 2}]}
    ]}
  ],
  [
    {pattern, "^000111.{162}"},
    {name,"msg7_binary_ack_4_destinations"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber1, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi2, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber2, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi3, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber3, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi4, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber4, int, [{min_length, 2},{max_length, 2}]}
    ]}
  ],
  [
    {pattern, "^010101.*"},
    {name,"msg21_aids_to_nav_report"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {typeOfAid, int, [{min_length, 5},{max_length, 5}]},
      {name, string, [{min_length, 120},{max_length, 120}]},
      {positionAccuracy, int, [{min_length, 1},{max_length, 1}]},
      {longitude, float, [{min_length, 28},{max_length, 28},{divisor, 600000}]},
      {latitude, float, [{min_length, 27},{max_length, 27},{divisor, 600000}]},
      {lengthFore, int, [{min_length, 9},{max_length, 9}]},
      {lengthAft, int, [{min_length, 9},{max_length, 9}]},
      {widthPort, int, [{min_length, 6},{max_length, 6}]},
      {widthStarboard, int, [{min_length, 6},{max_length, 6}]},
      {fixDeviceType, int, [{min_length, 4},{max_length, 4}]},
      {timestamp, int, [{min_length, 6},{max_length, 6}]},
      {offPosition, int, [{min_length, 1},{max_length, 1}]},
      {localApplicationData, int, [{min_length, 8},{max_length, 8}]},
      {raimFlag, int, [{min_length, 1},{max_length, 1}]},
      {virtual, int, [{min_length, 1},{max_length, 1}]},
      {assignedMode, int, [{min_length, 1},{max_length, 1}]},
      {spare, int, [{min_length, 1},{max_length, 1}]},
      {nameExtension, string, [{min_length, 0},{max_length, 84}]}
    ]}
  ],
  [
    {pattern, "^000101.*"},
    {name,"msg5_static_info"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {aisVersion, int, [{min_length, 2},{max_length, 2}]},
      {imoNumber, int, [{min_length, 30},{max_length, 30}]},
      {callSign, string, [{min_length, 42},{max_length, 42}]},
      {name, string, [{min_length, 120},{max_length, 120}]},
      {shipCargoType, int, [{min_length, 8},{max_length, 8}]},
      {lengthFore, int, [{min_length, 9},{max_length, 9}]},
      {lengthAft, int, [{min_length, 9},{max_length, 9}]},
      {widthPort, int, [{min_length, 6},{max_length, 6}]},
      {widthStarboard, int, [{min_length, 6},{max_length, 6}]},
      {fixDeviceType, int, [{min_length, 4},{max_length, 4}]},
      {etaMonth, int, [{min_length, 4},{max_length, 4}]},
      {etaDay, int, [{min_length, 5},{max_length, 5}]},
      {etaHour, int, [{min_length, 5},{max_length, 5}]},
      {etaMinute, int, [{min_length, 6},{max_length, 6}]},
      {draught, int, [{min_length, 8},{max_length, 8}]},
      {destination, string, [{min_length, 120},{max_length, 120}]},
      {dte, int, [{min_length, 1},{max_length, 1}]},
      {spare, int, [{min_length, 1},{max_length, 1}]}
    ]}
  ],
  [
    {pattern, "^001110.*"},
    {name,"msg14_safety_broadcast"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {text, string, [{min_length, 0},{max_length, 936}]}
    ]}
  ],
  [
    {pattern, "^001101.{162}"},
    {name,"msg13_safety_ack_4_destinations"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber1, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi2, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber2, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi3, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber3, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi4, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber4, int, [{min_length, 2},{max_length, 2}]}
    ]}
  ],
  [
    {pattern, "^001101.{130}"},
    {name,"msg13_safety_ack_3_destinations"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber1, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi2, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber2, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi3, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber3, int, [{min_length, 2},{max_length, 2}]}
    ]}
  ],
  [
    {pattern, "^000100.*"},
    {name,"msg4_station_info"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {utcYear, int, [{min_length, 14},{max_length, 14}]},
      {utcMonth, int, [{min_length, 4},{max_length, 4}]},
      {utcDay, int, [{min_length, 5},{max_length, 5}]},
      {utcHour, int, [{min_length, 5},{max_length, 5}]},
      {utcMinute, int, [{min_length, 6},{max_length, 6}]},
      {utcSecond, int, [{min_length, 6},{max_length, 6}]},
      {positionAccuracy, int, [{min_length, 1},{max_length, 1}]},
      {longitude, float, [{min_length, 28},{max_length, 28},{divisor, 600000}]},
      {latitude, float, [{min_length, 27},{max_length, 27},{divisor, 600000}]},
      {fixDeviceType, int, [{min_length, 4},{max_length, 4}]},
      {spare, int, [{min_length, 10},{max_length, 10}]},
      {raimFlag, int, [{min_length, 1},{max_length, 1}]},
      {communicationStatus, int, [{min_length, 19},{max_length, 19}]}
    ]}
  ],
  [
    {pattern, "^000111.{98}"},
    {name,"msg7_binary_ack_2_destinations"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber1, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi2, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber2, int, [{min_length, 2},{max_length, 2}]}
    ]}
  ],
  [
    {pattern, "^000111.{66}"},
    {name,"msg7_binary_ack_1_destination"},
    {fields, [
      {messageType, int, [{min_length, 6},{max_length, 6}]},
      {repeat, int, [{min_length, 2},{max_length, 2}]},
      {sourceMmsi, int, [{min_length, 30},{max_length, 30}]},
      {spare, int, [{min_length, 2},{max_length, 2}]},
      {destinationMmsi1, int, [{min_length, 30},{max_length, 30}]},
      {sequenceNumber1, int, [{min_length, 2},{max_length, 2}]}
    ]}
  ]
]).
